package android.support.v4.app;


import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;

import java.util.List;

import cn.ninegame.genericframework.ui.BaseDialogFragment;
import cn.ninegame.genericframework.ui.BaseFragment;

/**
 * <p>Title: ucweb</p>
 *
 * <p>Description: </p>
 * description
 * <p>Copyright: Copyright (c) 2020</p>
 *
 * <p>Company: ucweb.com</p>
 *
 * @author ZhuZhiFan (zhifan.zzf@alibaba-inc.com)
 * @date 2020-04-09
 */
public class FragmentHelper {

    /**
     * 获得栈顶BaseFragment
     */
    public static BaseFragment getTopBaseFragment(FragmentManager fragmentManager) {
        List<Fragment> fragmentList = fragmentManager.getFragments();

        for (int i = fragmentList.size() - 1; i >= 0; i--) {
            Fragment fragment = fragmentList.get(i);
            if (fragment instanceof BaseFragment) {
                return (BaseFragment) fragment;

            }
        }
        return null;
    }

    /**
     * 获得栈顶Fragment, 可能是 BaseFragment 或者 BaseDialogFragment
     */
    public static Fragment getTopFragment(FragmentManager fragmentManager) {
        List<Fragment> fragmentList = fragmentManager.getFragments();

        for (int i = fragmentList.size() - 1; i >= 0; i--) {
            Fragment fragment = fragmentList.get(i);
            if (fragment instanceof BaseFragment || fragment instanceof BaseDialogFragment) {
                return fragment;
            }
        }
        return null;
    }

    /**
     * 获得栈顶Fragment
     */
    public static Fragment getTopOriginFragment(FragmentManager fragmentManager) {
        List<Fragment> fragmentList = fragmentManager.getFragments();

        for (int i = fragmentList.size() - 1; i >= 0; i--) {
            Fragment fragment = fragmentList.get(i);
            if (fragment != null) {
                return fragment;
            }
        }
        return null;
    }

    /**
     * Get the topFragment from BackStack
     */
    public static BaseFragment getBackStackTopFragment(FragmentManager fragmentManager) {
        int count = fragmentManager.getBackStackEntryCount();

        for (int i = count - 1; i >= 0; i--) {
            FragmentManager.BackStackEntry entry = fragmentManager.getBackStackEntryAt(i);
            Fragment fragment = fragmentManager.findFragmentByTag(entry.getName());
            if (fragment instanceof BaseFragment) {
                BaseFragment gdFragment = (BaseFragment) fragment;
                return gdFragment;
            }
        }
        return null;
    }

    /**
     * Get the BackStack Fragment by index
     * @param fragmentManager
     * @param index
     * @return
     */
    public static Fragment getBackStactFragmentByIndex(FragmentManager fragmentManager, int index) {
        if (index < 0) {
            return null;
        } else {
            List<Fragment> fragmentList = fragmentManager.getFragments();

            if (index >= fragmentList.size()) {
                return null;
            } else {
                return fragmentList.get(index);
            }
        }
    }
}
