package cn.ninegame.genericframework.basic;


import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.util.SparseArray;

import java.util.Stack;

/**
 * ****************************************************************************
 * Copyright @ 2009 - 2015 www.9game.cn All Rights Reserved
 * <p/>
 * Creation    : 2015-03-18
 * Author      : lihq@ucweb.com
 * Description : Tell me what does this class do
 * ****************************************************************************
 */
public interface Environment {
    public void sendMessage(int messageId);
    public void sendMessage(int messageId,IMessageContext messageContext);
    public void sendMessage(int messageId,Bundle messageData);
    public void sendMessage(int messageId,IMessageContext messageContext,Bundle messageData);
    public void sendMessageForResult(int messageId,IMessageContext messageContext, Bundle messageData,IResultListener listener);
    public void sendMessageForResult(int messageId,Bundle messageData,IResultListener listener);
    public Bundle sendMessageSync(int messageId);
    public Bundle sendMessageSync(int messageId,IMessageContext messageContext);
    public Bundle sendMessageSync(int messageId,IMessageContext messageContext,Bundle messageData);
    public Bundle sendMessageSync(int messageId,Bundle messageData);
    public void sendMessage(String messageName);
    public void sendMessage(String messageName, Bundle messageData);
    public void sendMessage(String messageName,IMessageContext messageContext);
    public void sendMessage(String messageName,IMessageContext messageContext, Bundle messageData);
    public void sendMessageForResult(String messageName, IMessageContext messageContext,Bundle messageData,IResultListener listener);
    public void sendMessageForResult(String messageName, Bundle messageData,IResultListener listener);
    public Bundle sendMessageSync(String messageName);
    public Bundle sendMessageSync(String messageName, IMessageContext messageContext);
    public Bundle sendMessageSync(String messageName, Bundle messageData);
    public Bundle sendMessageSync(String messageName, IMessageContext messageContext,Bundle messageData);



    public int getMessageIdByName(String messageName);
    public Context getApplicationContext();
    public void setApplicationContext(Context context);
    public void sendNotification(Notification notification);
    public void sendNotification(int notificationId,Bundle bundleData);
    public void sendNotification(String notificationName,Bundle bundleData);
    public void registerNotification(String notificationName, INotify notify);
    public void registerNotificationWithId(int notificationId, INotify notify);
    public void unregisterNotification(String notificationName, INotify notify);
    public void unregisterNotificationWithId(int notificationId, INotify notify);


    public Activity getCurrentActivity();
    public Activity popActivityStack();
    public void finishAllActivities();
    public void removeActivity(Activity activity);
    public SparseArray<Stack<Activity>> getActivityStack();
    public int getActivityStackSize();
    public void pushToActivityStack(Activity activity);
    public void pushToActivityStackIfNeed(Activity activity);


    /**
     * 启动Fragment
     * @param fragmentID 目标Fragment的class name
     * @param param 启动参数
     * @param useAnim 是否使用切换动画
     * @param mode 启动模式：
     *       BaseFragment.LAUNCHER_MODE_NORMAL -> 新建Fragment并压入栈中；
     *       BaseFragment.LAUNCHER_MODE_SINGLE_TOP -> 若在栈顶匹配到Fragment，则调用{@link cn.com.funmeet.genericframework.ui.BaseFragment#onNewIntent()}
     *       BaseFragment.LAUNCHER_MODE_CLEAR_TOP -> 若在栈中匹配到Fragment，则将目标Fragment之上的其他Fragment弹出，
     *             并调用调用{@link cn.com.funmeet.genericframework.ui.BaseFragment#onNewIntent()}，
     *             没有匹配到则新建Fragment并压入栈中
     */
    public void startFragment(String fragmentID, Bundle param, boolean useAnim, int mode);
    public void startFragment(String fragmentID);
    public void startFragment(String fragmentID, Bundle param);
    public void startFragmentForResult(String fragmentID, Bundle param , IResultListener listener);
    public void startFragmentForResult(String fragmentID, Bundle param, IResultListener listener, boolean useAnim, int mode);
    public void startFragmentForResultNoIntercept(String fragmentID, Bundle param, IResultListener listener, boolean useAnim, int mode);

    public void startFragmentWithFlag(String fragmentID, Bundle param, boolean useAnim, int intentFlag);
    public void startFragmentWithFlagNoIntercept(String fragmentID, Bundle param, boolean useAnim, int intentFlag);

    public void startFragments(String[] fragmentIDs, Bundle[] params);
    public void startFragments(String[] fragmentIDs, Bundle[] params, int[] modes);
    public void startFragmentsNoIntercept(String[] fragmentIDs, Bundle[] params, int[] modes);

    public void startDialogFragment(String fragmentID, Bundle param);
    public void startDialogFragment(String fragmentID, Bundle param, IResultListener listener);
    public void startDialogFragmentNoIntercept(String fragmentID, Bundle param, IResultListener listener);

    public void reInitFragment(Fragment fragment);

    /**
     获取到一个fragment实例
     */
    public void loadFragment(String fragmentID,ILoadFragmentListener listener);

    public void startFragmentWithPop(String fragmentName, Bundle param);
    public void startFragmentWithPop(String fragmentName, Bundle param, boolean useAnim);
    public void startFragmentWithHide(String fragmentName, Bundle param);
    public void startFragmentWithHide(String fragmentName, Bundle param, boolean useAnim);

}
