package cn.ninegame.genericframework.config;

import java.io.File;

/**
 * ****************************************************************************
 * Copyright @ 2009 - 2015 www.9game.cn All Rights Reserved
 * <p/>
 * Creation    : 2016-01-27
 * Author      : lihq@ucweb.com
 * Description : 动态加载配置
 * ****************************************************************************
 */
public class DynamicLoadConfig {

    //>>>>>>>>>>>>>>>>>>>>>>>>>>>>module.apk的目录结构>>>>>>>>>>>>>>>>>>>

    /**
     * module后缀名
     */
    public static final String MODULE_NAME_SUFFIX = ".so";
    /**
     * module前缀
     */
    public static final String MODULE_NAME_PREFIX = "lib";
    /**
     * module后缀名，  此时的module apk 放置在 /data/data/packageName/1.0.0
     */
    public static final String MODULE_NAME_SUFFIX_IN_MODULE = ".apk";
    /**
     * module odex 文件后缀名
     */
    public static final String MODULE_ODEX_FILE_SUFFIX = ".dex";
    /**
     * module配置文件
     */
    public static final String MODULE_MANIFEST_FILE = "ModuleManifest.json";

    /**
     * /assets/目录下
     */
    public static final String MODULE_ASSETS_ROOT_PATH = "dl/modules";

    /**
     * 总配置文件路径
     */
    public static final String FILE_MODULES_CONFIG = MODULE_ASSETS_ROOT_PATH + File.separator + MODULE_MANIFEST_FILE;

    /**
     * so目录的entry
     */
    public static final String MODULE_SO_LIBS_ENTRY = "lib";

    /**
     * files目录的entry
     */
    public static final String MODULE_FILES_ENTRY = "files";

    /**
     * module manifest entry
     */
    public static final String MODULE_MANIFEST_ENTRY = MODULE_MANIFEST_FILE;


    //>>>>>>>>>>>>>>>>>>>>>>>>>>>>Flashbuild目录>>>>>>>>>>>>>>>>>>>
    /**
     *  Flashbuild 的根目录
     */
    public static final String MODULE_FLASHBUILD_ROOT = "/data/local/tmp/gundam/modules/";


    //>>>>>>>>>>>>>>>>>>>>>>>>>>>>module 私有目录结构>>>>>>>>>>>>>>>>>>>
    /**
     * /data/data/packagename/目录下
     */
    public static String MODULE_PRIVATE_ROOT_PATH = "modules";

    /**
     * 版本号(用于控制版本升级和降级)
     */
    public static final String MODULE_VESION = "version";

    /**
     * data目录存放module私有数据
     */
    public static final String MODULE_DATA = "data";

    /**
     * so目录存放module用到的.so文件
     */
    public static final String MODULE_SO = "so";

    /**
     * code_cache 存放odex文件
     */
    public static final String MODULE_CODE_CACHE = "code_cache";

    /**
     * module 签名文件
     */
    public static final String MODULE_SIGNATURE = "signature";

    /**
     * module 文件锁后缀名字
     *
     * module 文件锁由    MD5(moduleName) + ".lock"   组成
     */
    public static final String MODULE_LOCK_SUFFIX = ".lock";

    /**
     * module property文件，该文件用来保存一些跟版本有关的 key value
     */
    public static final String MODULE_PROPERTY = "property";
    /**
     * module odex 执行完成的标志
     */
    public static final String MODULE_ODEX_FINISH = "mof";
}
