package cn.ninegame.genericframework.module;

import android.content.Context;
import cn.ninegame.genericframework.basic.IController;
import cn.ninegame.genericframework.module.CacheOperation.Operation;
import cn.ninegame.genericframework.ui.BaseDialogFragment;
import cn.ninegame.genericframework.ui.BaseFragment;

/**
 * Created by lingcong on 2015/6/2.
 */
public interface IModuleEntry{
    public IController loadController(String controllerID);
    public BaseFragment loadFragment(String fragmentID);
    public BaseDialogFragment loadDialogFragment(String fragmentID);
    public Object loadControllerObject(String controllerID);
    public ModuleInfo getModuleInfo();
    public void setModuleInfo(ModuleInfo moduleInfo);
    String getModuleRootPath();
    String getModuleDataPath();
    String getModuleSoPath();
    void setBaseContext(Context base);
    Context getContext();
    int getModuleType();
    void loadModuleAsyn();
    boolean loadModuleSyn();
    int getLoadState();
    boolean isLoaded();
    boolean isNeverLoad();
    boolean isNotLoad();
    void cacheOperation(Operation op);
    void triggerCache();
    void addLoadModuleListener(ILoadModuleListener listener);
    public void setApplicationID(String applicationID);
    public void destroy();
}
